﻿
// Galaxy_Video_PlayerDlg.cpp : implementation file
//

#include "pch.h"
#include "framework.h"

extern "C"
{
#include "libavformat/avformat.h"
#include "libavcodec/avcodec.h"
#include "libswscale/swscale.h"
#include "libavutil/imgutils.h"
#include "libavutil/avutil.h"
}

#include "Galaxy_Video_Player.h"
#include "Galaxy_Video_PlayerDlg.h"
#include "DlgProxy.h"
#include "afxdialogex.h"

#pragma comment(lib, "avformat.lib")
#pragma comment(lib, "avutil.lib")
#pragma comment(lib, "avcodec.lib")


FLOAT color[] = { 0.25, 0.25, 0.25, 0.0 };

inline COLORREF RGBA(BYTE R, BYTE G, BYTE B, BYTE A)
{
	DWORD result = ((DWORD)(A) << 24) + RGB(R, G, B);

	return result;
}


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


enum AVPixelFormat get_pixel_format(struct AVCodecContext* s, const enum AVPixelFormat* fmt)
{
	if (s != nullptr)
	{
		if (s->codec != nullptr)
		{
			if (s->codec->type == AVMEDIA_TYPE_VIDEO)
			{
				while (*fmt != AV_PIX_FMT_NONE)
				{
					if (*fmt == AV_PIX_FMT_D3D11)
					{
						//return *fmt;
					}

					if (*fmt == AV_PIX_FMT_BGR32)
					{
						//return *fmt;
					}

					if (*fmt == AV_PIX_FMT_YUV420P)
					{
						return *fmt;
					}

					++fmt;
				}

				return AV_PIX_FMT_NONE;
			}
		}
	}

	return AV_PIX_FMT_NONE;

	while (*fmt != AV_PIX_FMT_NONE)
	{
		if (*fmt == AV_PIX_FMT_D3D11)
		{
			return *fmt;
		}

		++fmt;
	}

	return AV_PIX_FMT_NONE;
}

#define PLAY_TIMER_EVENT 2004
#define DECODE_SEND_FRAME_TIMER_EVENT 1981
#define DECODE_RECEIVE_FRAME_TIMER_EVENT 1987
#define MEMORY_CONTROL_TIMER_EVENT 2025



ID3D11Texture2D* CreateTexture_FromFMT_BGR32(ID3D11Device* myDevice, int w, int h, DWORD* dataABGR)
{
	ID3D11Texture2D* texture = nullptr;

	return nullptr;

	if (dataABGR != nullptr && myDevice != nullptr)
	{
		D3D11_TEXTURE2D_DESC texture_descriptor;
		D3D11_SUBRESOURCE_DATA subresource_data;

		memset(&texture_descriptor, 0, sizeof(D3D11_TEXTURE2D_DESC));
		memset(&subresource_data, 0, sizeof(D3D11_SUBRESOURCE_DATA));

		DWORD* buffer = (DWORD*)malloc(sizeof(DWORD) * (w * h));

		if (buffer != nullptr)
		{
			//ABGR
			for (int i = 0; i < h; i++)
			{
				for (int j = 0; j < w; j++)
				{
					buffer[i * w + j] = dataABGR[i * w + j];
				}
			}
			subresource_data.pSysMem = (void*)buffer;
			subresource_data.SysMemPitch = w * sizeof(DWORD);
			subresource_data.SysMemSlicePitch = w * h * sizeof(DWORD);

			texture_descriptor.Width = w;
			texture_descriptor.Height = h;
			texture_descriptor.MipLevels = 1;
			texture_descriptor.ArraySize = 1;

			texture_descriptor.SampleDesc.Count = 1;
			texture_descriptor.SampleDesc.Quality = 0;
			texture_descriptor.Usage = D3D11_USAGE_DEFAULT;
			texture_descriptor.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
			texture_descriptor.BindFlags = D3D11_BIND_RENDER_TARGET;

			texture_descriptor.CPUAccessFlags = 0;
			texture_descriptor.MiscFlags = 0;

			if (FAILED(myDevice->CreateTexture2D(&texture_descriptor, &subresource_data, &texture)))
			{
				int local_point = 0;
			}

			free(buffer);

			buffer = nullptr;
		}
	}

	return(texture);
}

ID3D11Texture2D* CreateTexture_FromYUV420P(ID3D11Device* myDevice, UINT w, UINT h, BYTE* Y, BYTE* U, BYTE* V, UINT d_w, UINT d_h)
{
	if (
		!(
			d_w != 0 && d_h != 0 && w != 0 && h != 0
			&&
			w >= d_w && h >= d_h
			&&
			myDevice != nullptr
			)
		)
	{
		return nullptr;
	}

	ID3D11Texture2D* texture = nullptr;

	if (Y != nullptr && U != nullptr && V != nullptr)
	{
		D3D11_TEXTURE2D_DESC texture_descriptor;
		D3D11_SUBRESOURCE_DATA subresource_data;

		memset(&texture_descriptor, 0, sizeof(D3D11_TEXTURE2D_DESC));
		memset(&subresource_data, 0, sizeof(D3D11_SUBRESOURCE_DATA));

		DWORD* buffer = (DWORD*)malloc(sizeof(DWORD) * (w * h));

		if (buffer != nullptr)
		{
			const double K_R = 0.3;
			const double K_B = 0.1;

			//YUV420P
			for (UINT i = 0; i < h; i++)
			{
				for (UINT j = 0; j < w; j++)
				{
					*((BYTE*)(&buffer[i * w + j]) + 0) = BYTE(
						+1.0 * Y[i * w + j]
						//+ 
						//+0.0 * (U[i / 2 * w / 2 + j / 2] - 128)
						+
						+2.0 * (1 - K_R) * (V[i / 2 * w / 2 + j / 2] - 128)
					);
					*((BYTE*)(&buffer[i * w + j]) + 1) = BYTE(
						+1.0 * Y[i * w + j]
						+
						-1.0 * K_B / (1.0 - K_R - K_B) * (U[i / 2 * w / 2 + j / 2] - 128)
						+
						-1.0 * K_R / (1.0 - K_R - K_B) * (V[i / 2 * w / 2 + j / 2] - 128)
					);
					*((BYTE*)(&buffer[i * w + j]) + 2) = BYTE(
						+1.0 * Y[i * w + j]
						+
						+1.0 * (U[i / 2 * w / 2 + j / 2] - 128)
						//+
						//+0.0 * (V[i / 2 * w / 2 + j / 2] - 128)
					);
					*((BYTE*)(&buffer[i * w + j]) + 3) = 0;
				}
			}

			/*///
			static int local_0 = 0;

			local_0++;

			if (local_0 >= 20)
			{
				local_0 = 0;
			}

			if (local_0 == 0)
			{
				CString result_file_name;

				std::filesystem::path path = std::filesystem::current_path();

				CStringW file_name;

				auto date_time = COleDateTime::GetTickCount();

				file_name.Format(CString(L"\\Frame%4d.%2d.%2d_%2d-%2d-%2d.png"),
					date_time.GetYear(), date_time.GetMonth(), date_time.GetDay(),
					date_time.GetHour(), date_time.GetMinute(), date_time.GetSecond());

				result_file_name = CStringW(path.c_str()) + file_name;

				CImage local_image;
				local_image.Create(w, h, 32);

				BYTE* rawData = (BYTE*)buffer;
				int width = local_image.GetWidth();
				int height = local_image.GetHeight();
				int bpp = local_image.GetBPP() / 8;
				int pitch = w * sizeof(DWORD);

				for (int y = 0; y < height; ++y) {
					for (int x = 0; x < width; ++x) {
						int index = y * pitch + x * bpp;
						local_image.SetPixel(x, y, RGBA(rawData[index], rawData[index + 1],
							rawData[index + 2], rawData[index + 3]));
					}
				}

				local_image.Save(result_file_name);
			}
			/*///

			DWORD* buffer_d = (DWORD*)malloc(sizeof(DWORD) * (d_w * d_h));

			if (buffer_d != nullptr)
			{
				memset(buffer_d, 0, sizeof(DWORD) * size_t(d_w * d_h));

				double h_r = double(d_h) / double(h);
				double w_r = double(d_w) / double(w);

				INT zero_d_w = 0;
				INT zero_d_h = 0;

				if (w_r > h_r)
				{
					zero_d_h = INT(double(d_w) - double(w) * h_r) / 2;
				}
				else
				{
					if (w_r < h_r)
					{
						zero_d_w = INT(double(d_h) - double(h) * w_r) / 2;
					}
				}


				for (INT i = zero_d_h; i < INT(d_h) - zero_d_h; i++)
				{
					for (INT j = zero_d_w; j < INT(d_w) - zero_d_w; j++)
					{
						INT s_i = INT((double(i) - zero_d_h) / double(d_h - 2 * zero_d_h) * double(h));
						INT s_j = INT((double(j) - zero_d_w) / double(d_w - 2 * zero_d_w) * double(w));
												
						if (s_i < 0)
						{
							s_i = 0;
						}
						if (s_j < 0)
						{
							s_j = 0;
						}

						if (s_i >= INT(h))
						{
							s_i = INT(h - 1);
						}
						if (s_j >= INT(w))
						{
							s_j = INT(w - 1);
						}

						INT d_i = INT(i);
						INT d_j = INT(j);
						
						buffer_d[d_i * d_w + d_j] = buffer[s_i * w + s_j];
					}
				}

				subresource_data.pSysMem = (void*)buffer_d;
				subresource_data.SysMemPitch = d_w * sizeof(DWORD);
				subresource_data.SysMemSlicePitch = d_w * d_h * sizeof(DWORD);

				texture_descriptor.Width = d_w;
				texture_descriptor.Height = d_h;
				texture_descriptor.MipLevels = 1;
				texture_descriptor.ArraySize = 1;

				texture_descriptor.SampleDesc.Count = 1;
				texture_descriptor.SampleDesc.Quality = 0;
				texture_descriptor.Usage = D3D11_USAGE_DEFAULT;
				texture_descriptor.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
				texture_descriptor.BindFlags = D3D11_BIND_RENDER_TARGET;

				texture_descriptor.CPUAccessFlags = 0;
				texture_descriptor.MiscFlags = 0;

				if (FAILED(myDevice->CreateTexture2D(&texture_descriptor, &subresource_data, &texture)))
				{
					int local_point = 0;
				}

				free(buffer_d);

				buffer_d = nullptr;
			}

			free(buffer);

			buffer = nullptr;
		}
	}

	return texture;
}



// CGalaxyVideoPlayerDlg dialog


IMPLEMENT_DYNAMIC(CGalaxyVideoPlayerDlg, CDialogEx);

CGalaxyVideoPlayerDlg::CGalaxyVideoPlayerDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_GALAXY_VIDEO_PLAYER_DIALOG, pParent)
{
	EnableActiveAccessibility();
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = nullptr;

	pDevice = nullptr;
	pDeviceContext = nullptr;
	pSwapChain = nullptr;
	pRenderTargetView = nullptr;

	pDirectSound = nullptr;

	decoder = nullptr;
	
	format_context = nullptr;

	frames_rate = 0;

	video_stream = nullptr;
	video_stream_index = 0;

	decoding_active = false;

	paused = true;

	stopped = true;

	error_status_is_okay = true;

	memory_control_alarm = false;
}

CGalaxyVideoPlayerDlg::~CGalaxyVideoPlayerDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to null, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != nullptr)
		m_pAutoProxy->m_pDialog = nullptr;
}

void CGalaxyVideoPlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, file_path);
	DDX_Control(pDX, IDC_STATIC_PICTURE, video_window);
	DDX_Control(pDX, IDC_STATIC_STATUS, application_status);
	DDX_Control(pDX, IDC_BUTTON1, Button1);
	DDX_Control(pDX, IDC_BUTTON2, Button2);
	DDX_Control(pDX, IDC_BUTTON3, Button3);
	DDX_Control(pDX, IDC_BUTTON4, Button4);
	DDX_Control(pDX, IDC_BUTTON5, Button5);
	DDX_Control(pDX, IDC_BUTTON6, Button6);
}

BEGIN_MESSAGE_MAP(CGalaxyVideoPlayerDlg, CDialogEx)
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CGalaxyVideoPlayerDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CGalaxyVideoPlayerDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CGalaxyVideoPlayerDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CGalaxyVideoPlayerDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CGalaxyVideoPlayerDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CGalaxyVideoPlayerDlg::OnBnClickedButton6)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CGalaxyVideoPlayerDlg message handlers

BOOL CGalaxyVideoPlayerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SetWindowTextW(L"Galaxy Video Player");

	CSingleLock lock(&render_critical_section);

	lock.Lock();

	Button1.EnableWindow(TRUE);
	Button2.EnableWindow(FALSE);
	Button3.EnableWindow(FALSE);
	Button4.EnableWindow(FALSE);
	Button5.EnableWindow(FALSE);
	Button6.EnableWindow(TRUE);

	// initialize DirectX
	{
		DXGI_SWAP_CHAIN_DESC swap_chain_descriptor = {};
		swap_chain_descriptor.Windowed = TRUE;
		swap_chain_descriptor.OutputWindow = video_window.m_hWnd;
		swap_chain_descriptor.BufferCount = 2;
		swap_chain_descriptor.BufferDesc.Width = 0;
		swap_chain_descriptor.BufferDesc.Height = 0;
		swap_chain_descriptor.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
		swap_chain_descriptor.BufferDesc.RefreshRate.Numerator = 60;
		swap_chain_descriptor.BufferDesc.RefreshRate.Denominator = 1;
		swap_chain_descriptor.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
		swap_chain_descriptor.SampleDesc.Count = 1;
		swap_chain_descriptor.SampleDesc.Quality = 0;
		swap_chain_descriptor.SwapEffect = DXGI_SWAP_EFFECT_DISCARD;
		swap_chain_descriptor.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;

		D3D_FEATURE_LEVEL feature_level;
		const D3D_FEATURE_LEVEL feature_level_array[] = { D3D_FEATURE_LEVEL_11_0, D3D_FEATURE_LEVEL_10_0, D3D_FEATURE_LEVEL_9_1, };
		if (
			SUCCEEDED(
				D3D11CreateDeviceAndSwapChain(NULL, D3D_DRIVER_TYPE_HARDWARE, NULL, D3D11_CREATE_DEVICE_DEBUG, feature_level_array, 3, D3D11_SDK_VERSION, &swap_chain_descriptor, &pSwapChain, &pDevice, &feature_level, &pDeviceContext)
			)
			)
		{

			ID3D11Texture2D* pBackBuffer;
			if (pSwapChain != nullptr)
			{
				if (
					SUCCEEDED(
						pSwapChain->GetBuffer(0, IID_PPV_ARGS(&pBackBuffer))
					)
					)
				{
					if (pDevice != nullptr)
					{
						if (
							SUCCEEDED(
								pDevice->CreateRenderTargetView(pBackBuffer, NULL, &pRenderTargetView)
							)
							)
						{
							if (pBackBuffer != nullptr)
							{
								pBackBuffer->Release();
							}
						}
					}
				}
			}


			RECT rc;
			video_window.GetWindowRect(&rc);

			D3D11_VIEWPORT viewport;
			viewport.MinDepth = 0;
			viewport.MaxDepth = 1;
			viewport.TopLeftX = 0;
			viewport.TopLeftY = 0;
			viewport.Width = FLOAT(rc.right - rc.left);
			viewport.Height = FLOAT(rc.bottom - rc.top);
			pDeviceContext->RSSetViewports(1u, &viewport);

		}
	}

	if (pDeviceContext != nullptr)
	{
		if (pRenderTargetView != nullptr)
		{
			// draw the initial gray window
			pDeviceContext->ClearRenderTargetView(pRenderTargetView, color);
			if (pSwapChain != nullptr)
			{
				pSwapChain->Present(1, 0);
			}
		}
	}

	DirectSoundCreate8(nullptr, &pDirectSound, nullptr);
	if (pDirectSound != nullptr)
	{
		pDirectSound->SetCooperativeLevel(m_hWnd, DSSCL_NORMAL);
	}

	SetTimer(PLAY_TIMER_EVENT, 1000 / 20, nullptr);
	SetTimer(DECODE_SEND_FRAME_TIMER_EVENT, 1000 / 1000, nullptr);
	SetTimer(DECODE_RECEIVE_FRAME_TIMER_EVENT, 1000 / 1000, nullptr);

	SetTimer(MEMORY_CONTROL_TIMER_EVENT, 1000 / 1, nullptr);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGalaxyVideoPlayerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();

		Render();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGalaxyVideoPlayerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CGalaxyVideoPlayerDlg::OnClose()
{
	CSingleLock lock(&cleaning_critical_section);

	lock.Lock();

	clear_direct_sound();
	clear_direct_3d();
	clear_memory();
	clear_decoding();

	lock.Unlock();

	if (CanExit())
		CDialogEx::OnClose();
}

void CGalaxyVideoPlayerDlg::OnOK()
{
	CSingleLock lock(&cleaning_critical_section);

	lock.Lock();

	clear_direct_sound();
	clear_direct_3d();
	clear_memory();
	clear_decoding();

	lock.Unlock();

	if (CanExit())
		CDialogEx::OnOK();
}

void CGalaxyVideoPlayerDlg::OnCancel()
{
	CSingleLock lock(&cleaning_critical_section);

	lock.Lock();

	clear_direct_sound();
	clear_direct_3d();
	clear_memory();
	clear_decoding();

	lock.Unlock();

	if (CanExit())
		CDialogEx::OnCancel();
}

BOOL CGalaxyVideoPlayerDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != nullptr)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}


//	Open
void CGalaxyVideoPlayerDlg::OnBnClickedButton1()
{
	Open();

	if (IsErrorStatusOkay())
	{
		Button1.EnableWindow(FALSE);
		Button2.EnableWindow(TRUE);
		Button3.EnableWindow(FALSE);
		Button4.EnableWindow(FALSE);
		Button5.EnableWindow(FALSE);
		Button6.EnableWindow(TRUE);
	}
}


//	Play
void CGalaxyVideoPlayerDlg::OnBnClickedButton2()
{
	StartPlaying();

	if (IsErrorStatusOkay())
	{
		Button1.EnableWindow(FALSE);
		Button2.EnableWindow(FALSE);
		Button3.EnableWindow(TRUE);
		Button4.EnableWindow(FALSE);
		Button5.EnableWindow(TRUE);
		Button6.EnableWindow(FALSE);
	}
}


//	Pause
void CGalaxyVideoPlayerDlg::OnBnClickedButton3()
{
	Pause();

	if (IsErrorStatusOkay())
	{
		Button1.EnableWindow(FALSE);
		Button2.EnableWindow(FALSE);
		Button3.EnableWindow(FALSE);
		Button4.EnableWindow(TRUE);
		Button5.EnableWindow(TRUE);
		Button6.EnableWindow(FALSE);
	}
}


//	Resume
void CGalaxyVideoPlayerDlg::OnBnClickedButton4()
{
	Resume();

	if (IsErrorStatusOkay())
	{
		Button1.EnableWindow(FALSE);
		Button2.EnableWindow(FALSE);
		Button3.EnableWindow(TRUE);
		Button4.EnableWindow(FALSE);
		Button5.EnableWindow(TRUE);
		Button6.EnableWindow(FALSE);
	}
}


//	Stop
void CGalaxyVideoPlayerDlg::OnBnClickedButton5()
{
	Stop();

	if (IsErrorStatusOkay())
	{
		Button1.EnableWindow(TRUE);
		Button2.EnableWindow(FALSE);
		Button3.EnableWindow(FALSE);
		Button4.EnableWindow(FALSE);
		Button5.EnableWindow(FALSE);
		Button6.EnableWindow(TRUE);
	}
}


//	Exit
void CGalaxyVideoPlayerDlg::OnBnClickedButton6()
{
	Exit();

	if (IsErrorStatusOkay())
	{
		Button1.EnableWindow(FALSE);
		Button2.EnableWindow(FALSE);
		Button3.EnableWindow(FALSE);
		Button4.EnableWindow(FALSE);
		Button5.EnableWindow(FALSE);
		Button6.EnableWindow(FALSE);
	}
}


void CGalaxyVideoPlayerDlg::clear_direct_sound()
{
	if (pDirectSound != nullptr)
	{
		pDirectSound->Release();
		pDirectSound = nullptr;
	}
}

void CGalaxyVideoPlayerDlg::clear_direct_3d()
{
	if (pRenderTargetView != nullptr)
	{
		pRenderTargetView->Release();
		pRenderTargetView = nullptr;
	}

	if (pSwapChain != nullptr)
	{
		pSwapChain->Release();
		pSwapChain = nullptr;
	}

	if (pDeviceContext != nullptr)
	{
		pDeviceContext->Release();
		pDeviceContext = nullptr;
	}

	if (pDevice != nullptr)
	{
		pDevice->Release();
		pDevice = nullptr;
	}
}

void CGalaxyVideoPlayerDlg::clear_memory()
{
	if (frames.size() != 0)
	{
		for (auto &iterator_1 = frames.begin(); iterator_1 != frames.end(); iterator_1++)
		{
			auto current_frame = *iterator_1;
			if (current_frame != nullptr)
			{
				av_frame_free(&current_frame);

				current_frame = nullptr;
			}
		}

		frames.clear();
	}
}

void CGalaxyVideoPlayerDlg::clear_decoding()
{
	avcodec_close(decoder);
	avcodec_free_context(&decoder);
	avformat_close_input(&format_context);

	decoder = nullptr;
	format_context = nullptr;
}

void CGalaxyVideoPlayerDlg::Render()
{
	CSingleLock lock(&render_critical_section);

	lock.Lock();

	if (!paused && !stopped)
	{
		CSingleLock lock(&cleaning_critical_section);

		lock.Lock();

		if (pDevice != nullptr)
		{
			{
				if (pDeviceContext != nullptr && pSwapChain != nullptr)
				{
					// fill with random color every time the timer fires
					//color[0] = FLOAT((rand() % 100) / 100.0);
					//color[1] = FLOAT((rand() % 100) / 100.0);
					//color[2] = FLOAT((rand() % 100) / 100.0);
					//color[3] = 0.0;

					if (frames.size() != 0)
					{
						pDeviceContext->ClearRenderTargetView(pRenderTargetView, color);

						auto &iterator_1 = frames.begin();

						auto current_frame = *iterator_1;

						if (current_frame != nullptr)
						{
							{
								if (pSwapChain != nullptr)
								{
									ID3D11Texture2D* pBackBuffer = nullptr;

									if (
										SUCCEEDED(
											pSwapChain->GetBuffer(0, IID_PPV_ARGS(&pBackBuffer))
										)
										)
									{
										if (pDevice != nullptr)
										{
											if (
												SUCCEEDED(
													pDevice->CreateRenderTargetView(pBackBuffer, NULL, &pRenderTargetView)
												)
												)
											{
												ID3D11Texture2D* pDataBuffer = nullptr;

												if (current_frame->format == AV_PIX_FMT_D3D11)
												{
													pDataBuffer = (ID3D11Texture2D*)current_frame->buf[0];
												}
												else
												{
													if (current_frame->format == AV_PIX_FMT_BGR32)
													{
														if (current_frame != nullptr)
														{
															if (current_frame->buf[0] != nullptr)
															{
																if (current_frame->buf[0]->data != nullptr)
																{
																	pDataBuffer = CreateTexture_FromFMT_BGR32(pDevice,
																		current_frame->width, current_frame->height,
																		(DWORD*)(current_frame->buf[0]->data));
																}
															}
														}
													}
													else
													{
														if (current_frame->format == AV_PIX_FMT_YUV420P)
														{
															if (current_frame != nullptr)
															{
																if (
																	current_frame->buf[0] != nullptr
																	&&
																	current_frame->buf[1] != nullptr
																	&&
																	current_frame->buf[2] != nullptr
																	)
																{
																	if (
																		current_frame->buf[0]->data != nullptr
																		&&
																		current_frame->buf[1]->data != nullptr
																		&&
																		current_frame->buf[2]->data != nullptr
																		)
																	{
																		if (pBackBuffer != nullptr)
																		{
																			D3D11_TEXTURE2D_DESC destination_texture_descriptor;
																			pBackBuffer->GetDesc(&destination_texture_descriptor);

																			pDataBuffer = CreateTexture_FromYUV420P(pDevice,
																				UINT(current_frame->width), UINT(current_frame->height),
																				(BYTE*)(current_frame->buf[0]->data),
																				(BYTE*)(current_frame->buf[1]->data),
																				(BYTE*)(current_frame->buf[2]->data),
																				destination_texture_descriptor.Width,
																				destination_texture_descriptor.Height
																			);
																		}
																	}
																}
															}
														}
													}

													if (pDataBuffer != nullptr && pBackBuffer != nullptr)
													{
														D3D11_TEXTURE2D_DESC source_texture_descriptor;
														D3D11_TEXTURE2D_DESC destination_texture_descriptor;

														pDataBuffer->GetDesc(&source_texture_descriptor);
														pBackBuffer->GetDesc(&destination_texture_descriptor);

														if (source_texture_descriptor.Width == destination_texture_descriptor.Width &&
															source_texture_descriptor.Height == destination_texture_descriptor.Height)
														{
															pDeviceContext->CopyResource(pBackBuffer, pDataBuffer);
														}
														else
														{

														}

														pDataBuffer->Release();
													}
													else
													{
														set_application_status(L"Failed to create texture.\n", false);
													}
												}

												if (pSwapChain != nullptr)
												{
													set_application_status(L"Playing.\n", true);

													pSwapChain->Present(1, 0);
												}

												pBackBuffer->Release();
											}
										}
									}
								}
							}

							av_frame_free(&current_frame);

							current_frame = nullptr;
						}

						frames.pop_front();
					}
				}
			}
		}
	}
}

void CGalaxyVideoPlayerDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == PLAY_TIMER_EVENT)
	{
		Render();
	}

	if (nIDEvent == DECODE_RECEIVE_FRAME_TIMER_EVENT)
	{
		Decode_Receive();
	}

	if (nIDEvent == DECODE_SEND_FRAME_TIMER_EVENT)
	{
		Decode_Send();
	}

	if (nIDEvent == MEMORY_CONTROL_TIMER_EVENT)
	{
		Control_Memory();
	}	

	CDialogEx::OnTimer(nIDEvent);
}


void CGalaxyVideoPlayerDlg::set_application_status(CString message, bool set_error_status_is_okay)
{
	application_status.SetWindowTextW(message.GetBuffer());

	error_status_is_okay = set_error_status_is_okay;
}

void CGalaxyVideoPlayerDlg::Open()
{
	CSingleLock lock(&render_critical_section);

	lock.Lock();

	CFileDialog file_dialog(TRUE);

	if (file_dialog.DoModal() == IDOK)
	{
		input_file = file_dialog.GetPathName();

		file_path.SetWindowTextW(input_file);

		paused = true;
		stopped = true;

		set_application_status(L"Selected.\n", true);
	}
}

void CGalaxyVideoPlayerDlg::StartPlaying()
{
	CSingleLock lock(&render_critical_section);

	lock.Lock();

	stopped = false;

	int response = 0;

	format_context = avformat_alloc_context();
	if (format_context == nullptr)
	{
		set_application_status(L"Could not allocate memory for the input format context.\n", false);

		return;
	}

	// Open video file
	CStringA input_file_a = CW2A(input_file, CP_UTF8);
	response = avformat_open_input(&format_context, input_file_a, NULL, NULL);
	if (response < 0)
	{
		avformat_free_context(format_context);

		set_application_status(L"Could not open the input file.\n", false);

		return;
	}

	// Retrieve stream information
	response = avformat_find_stream_info(format_context, NULL);
	if (response < 0)
	{
		avformat_free_context(format_context);

		set_application_status(L"Unable to find stream info.\n", false);

		return;
	}

	// find primary video stream
	const AVCodec* vcodec = nullptr;
	response = av_find_best_stream(format_context, AVMEDIA_TYPE_VIDEO, -1, -1, &vcodec, 0);
	if (response < 0)
	{
		avformat_free_context(format_context);

		set_application_status(L"Failed to find best stream.\n", false);

		return;
	}

	video_stream_index = response;
	video_stream = format_context->streams[video_stream_index];

	// open video decoder context
	decoder = avcodec_alloc_context3(vcodec);
	if (decoder != nullptr)
	{
		if (avcodec_parameters_to_context(decoder, video_stream->codecpar) < 0)
		{
			avformat_free_context(format_context);

			set_application_status(L"Can not copy input video codec parameters to video decoder context.\n", false);

			return;
		}

		response = avcodec_open2(decoder, vcodec, nullptr);
		if (response < 0)
		{
			avformat_free_context(format_context);

			set_application_status(L"Failed to open codec.\n", false);

			return;
		}

		frames_rate = decoder->framerate.num / decoder->framerate.den;

		decoder->get_format = get_pixel_format;
	}
	else
	{
		avformat_free_context(format_context);

		set_application_status(L"Failed to allocate decoder.\n", false);

		return;
	}

	if (frames_rate == 0)
	{
		frames_rate = 20;
	}

	paused = false;
	stopped = false;

	set_application_status(L"Opened.\n", true);
}

void CGalaxyVideoPlayerDlg::Pause()
{
	CSingleLock lock(&render_critical_section);

	lock.Lock();

	paused = true;

	set_application_status(L"Paused.\n", true);
}

void CGalaxyVideoPlayerDlg::Resume()
{
	CSingleLock lock(&render_critical_section);

	lock.Lock();

	paused = false;

	set_application_status(L"Resumed.\n", true);
}

void CGalaxyVideoPlayerDlg::Stop()
{
	CSingleLock lock(&render_critical_section);

	lock.Lock();

	stopped = true;

	CSingleLock cleaning_lock(&cleaning_critical_section);

	cleaning_lock.Lock();

	clear_memory();
	clear_decoding();

	set_application_status(L"Stoped.\n", true);
}

void CGalaxyVideoPlayerDlg::Exit()
{
	Stop();

	OnOK();
}


void CGalaxyVideoPlayerDlg::Decode_Send()
{
	if (!stopped && !memory_control_alarm)
	{
		if (!decoding_active)
		{
			decoding_active = true;

			if (decoder != nullptr)
			{
				if (format_context != nullptr)
				{
					// decoding loop		
					int response = 0;
					AVPacket* packet = av_packet_alloc();

					if (packet != nullptr)
					{
						// read packet from input file
						response = av_read_frame(format_context, packet);

						if (response < 0 && response != AVERROR_EOF)
						{
							set_application_status(L"Failed to read frame.\n", false);
						}
						else
						{
							if (response != AVERROR_EOF)
							{

								if (packet->stream_index == video_stream_index)
								{
									response = avcodec_send_packet(decoder, packet);

									if (response < 0 && response != AVERROR_EOF)
									{
										set_application_status(L"Failed to send packet.\n", false);
									}
									else
									{
									}
								}
							}
						}
						av_packet_unref(packet);

						av_packet_free(&packet);

						packet = nullptr;
					}
				}
			}

			decoding_active = false;
		}
	}
}

void CGalaxyVideoPlayerDlg::Decode_Receive()
{
	if (!stopped && !memory_control_alarm)
	{
		if (decoder != nullptr)
		{
			AVFrame* frame = av_frame_alloc();

			if (frame == nullptr)
			{
				set_application_status(L"Failed to allocate frame.\n", false);
			}
			else
			{
				int response = avcodec_receive_frame(decoder, frame);

				for (;;)
				{
					if (response == AVERROR(EAGAIN))
					{
						av_frame_free(&frame);

						frame = nullptr;

						break;
					}

					if (response < 0)
					{
						av_frame_free(&frame);

						frame = nullptr;

						set_application_status(L"Failed to receive frame.\n", false);
					}
					else
					{
						CSingleLock lock(&cleaning_critical_section);

						lock.Lock();

						frames.push_back(frame);
					}
					break;
				}
			}
		}
	}
}

bool CGalaxyVideoPlayerDlg::IsErrorStatusOkay()
{
	return error_status_is_okay;
}

void CGalaxyVideoPlayerDlg::Control_Memory()
{
	MEMORYSTATUSEX memory_status;

	memset(&memory_status, 0, sizeof(MEMORYSTATUSEX));
	memory_status.dwLength = sizeof(MEMORYSTATUSEX);

	if (GlobalMemoryStatusEx(&memory_status)) {
		DWORDLONG total_memory = memory_status.ullTotalPhys;
		DWORDLONG available_memory = memory_status.ullAvailPhys;

		if (total_memory != 0)
		{
			const DWORDLONG percents_of_memory_allowed = 10;

			if (available_memory <= total_memory / 100 * percents_of_memory_allowed)
			{
				memory_control_alarm = true;

				set_application_status(L"Available less than 10 % of total memory - processing (decoding) will be stopped.\n", false);
			}
			else
			{
				memory_control_alarm = false;
			}
		}
		else
		{
			set_application_status(L"Failed to retrieve memory status: installed zero bytes of memory.\n", false);
		}
	}
	else
	{
		set_application_status(L"Failed to retrieve memory status.\n", false);
	}
}
